Index: branches/1.3/gui/scripts/flowvisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4848)
@@ -1977,10 +2049,10 @@
         }
         set _isomarkers($tf) $list
-        updateTransferFunctions
+        updatetransferfuncs
     }
     return $bool
 }
 
-itcl::body Rappture::FlowvisViewer::overMarker { marker x } {
+itcl::body Rappture::FlowvisViewer::overmarker { marker x } {
     set tf [$marker transferfunc]
     if { [info exists _isomarkers($tf)] } {
@@ -1997,33 +2069,36 @@
 }
 
-itcl::body Rappture::FlowvisViewer::limits { cname } {
-    set _limits(v) [list 0.0 1.0]
-    if { ![info exists _style2objs($cname)] } {
-        puts stderr "no style2objs for $cname cname=($cname)"
+itcl::body Rappture::FlowvisViewer::limits { tf } {
+    set _limits(vmin) 0.0
+    set _limits(vmax) 1.0
+    if { ![info exists _style2objs($tf)] } {
+        puts stderr "no style2objs for $tf tf=($tf)"
         return [array get _limits]
     }
     set min ""; set max ""
-    foreach tag [GetDatasetsWithComponent $cname] {
+    foreach {dataobj comp} $_style2objs($tf) {
+        set tag $dataobj-$comp
         if { ![info exists _serverObjs($tag)] } {
             puts stderr "$tag not in serverObjs?"
             continue
         }
-        if { ![info exists _limits($tag)] } {
+        if { ![info exists _limits($tag-min)] } {
             puts stderr "$tag no min?"
             continue
         }
-        foreach {vmin vmax} $_limits($tag) break
-        if { $min == "" || $min > $vmin } {
-            set min $vmin
-        }
-        if { $max == "" || $max < $vmax } {
-            set max $vmax
-        }
-    }
-    if { $min != "" && $max != "" } {
-        set _limits(v) [list $min $max]
-        set _limits($cname) [list $min $max]
-    }
-    return $_limits($cname)
+        if { $min == "" || $min > $_limits($tag-min) } {
+            set min $_limits($tag-min)
+        }
+        if { $max == "" || $max < $_limits($tag-max) } {
+            set max $_limits($tag-max)
+        }
+    }
+    if { $min != "" } {
+        set _limits(vmin) $min
+    } 
+    if { $max != "" } {
+        set _limits(vmax) $max
+    }
+    return [array get _limits]
 }
 
@@ -2114,4 +2189,14 @@
 
 itcl::body Rappture::FlowvisViewer::BuildVolumeTab {} {
+    foreach { key value } {
+        light2side      1
+        light           40
+        transp          50
+        opacity         100
+        thickness       350
+    } {
+        set _settings($this-$key) $value
+    }
+
     set inner [$itk_component(main) insert end \
         -title "Volume Settings" \
@@ -2141,4 +2226,11 @@
     label $inner.bright -text "Surface" -font $fg
 
+    label $inner.fog -text "Clear" -font $fg
+    ::scale $inner.transp -from 0 -to 100 -orient horizontal \
+        -variable [itcl::scope _settings($this-transp)] \
+        -width 10 \
+        -showvalue off -command [itcl::code $this AdjustSetting transp]
+    label $inner.plastic -text "Opaque" -font $fg
+
     label $inner.clear -text "Clear" -font $fg
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
@@ -2160,5 +2252,23 @@
     }
 
-    $inner.colormap choices insert end [GetColormapList -includeNone]
+    $inner.colormap choices insert end \
+        "BCGYR"              "BCGYR"            \
+        "BGYOR"              "BGYOR"            \
+        "blue"               "blue"             \
+        "blue-to-brown"      "blue-to-brown"    \
+        "blue-to-orange"     "blue-to-orange"   \
+        "blue-to-grey"       "blue-to-grey"     \
+        "green-to-magenta"   "green-to-magenta" \
+        "greyscale"          "greyscale"        \
+        "nanohub"            "nanohub"          \
+        "rainbow"            "rainbow"          \
+        "spectral"           "spectral"         \
+        "ROYGB"              "ROYGB"            \
+        "RYGCB"              "RYGCB"            \
+        "brown-to-blue"      "brown-to-blue"    \
+        "grey-to-blue"       "grey-to-blue"     \
+        "orange-to-blue"     "orange-to-blue"   \
+	"none"		     "none"
+
     $itk_component(colormap) value "BCGYR"
     bind $inner.colormap <<Value>> \
@@ -2172,7 +2282,7 @@
         3,1 $inner.light -cspan 2 -pady 2 -fill x \
         3,3 $inner.bright -anchor w -pady 2 \
-        4,0 $inner.clear -anchor e -pady 2 \
-        4,1 $inner.opacity -cspan 2 -pady 2 -fill x \
-        4,3 $inner.opaque -anchor w -pady 2 \
+        4,0 $inner.fog -anchor e -pady 2 \
+        4,1 $inner.transp -cspan 2 -pady 2 -fill x \
+        4,3 $inner.plastic -anchor w -pady 2 \
         5,0 $inner.thin -anchor e -pady 2 \
         5,1 $inner.thickness -cspan 2 -pady 2 -fill x\
@@ -2302,5 +2412,4 @@
         0,0 $inner.view_l -anchor e -pady 2 \
         0,1 $inner.view -anchor w -pady 2 
-    blt::table configure $inner r0 -resize none
 
     set row 1 
@@ -2310,8 +2419,6 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _settings($this-$tag)]
-        bind $inner.${tag} <Return> \
-            [itcl::code $this camera set -${tag}]
-        bind $inner.${tag} <KP_Enter> \
-            [itcl::code $this camera set -${tag}]
+        bind $inner.${tag} <KeyPress-Return> \
+            [itcl::code $this camera set ${tag}]
         blt::table $inner \
             $row,0 $inner.${tag}label -anchor e -pady 2 \
@@ -2321,5 +2428,5 @@
     }
 
-    blt::table configure $inner c* -resize none
+    blt::table configure $inner c* r* -resize none
     blt::table configure $inner c2 -resize expand
     blt::table configure $inner r$row -resize expand
@@ -2474,4 +2581,7 @@
 itcl::body Rappture::FlowvisViewer::SlicerTip {axis} {
     set val [$itk_component(${axis}CutScale) get]
+#    set val [expr {0.01*($val-50)
+#        *($_limits(${axis}max)-$_limits(${axis}min))
+#          + 0.5*($_limits(${axis}max)+$_limits(${axis}min))}]
     return "Move the [string toupper $axis] cut plane.\nCurrently:  $axis = $val%"
 }
@@ -2515,25 +2625,25 @@
         }
         "set" {
-            set what [lindex $args 0]
-            set x $_settings(${this}${what})
+            set who [lindex $args 0]
+            set x $_settings($this-$who)
             set code [catch { string is double $x } result]
             if { $code != 0 || !$result } {
-                set _settings(${this}${what}) $_view($what)
+                set _settings($this-$who) $_view($who)
                 return
             }
-            switch -- $what {
-                "-xpan" - "-ypan" {
-                    set _view($what) $_settings(${this}${what})
+            switch -- $who {
+                "xpan" - "ypan" {
+                    set _view($who) $_settings($this-$who)
                     PanCamera
                 }
-                "-qx" - "-qy" - "-qz" - "-qw" {
-                    set _view($what) $_settings(${this}${what})
-                    set q [ViewToQuaternion]
+                "qx" - "qy" - "qz" - "qw" {
+                    set _view($who) $_settings($this-$who)
+                    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
                     $_arcball quaternion $q
                     SendCmd "camera orient $q"
                 }
-                "-zoom" {
-                    set _view($what) $_settings(${this}${what})
-                    SendCmd "camera zoom $_view($what)"
+                "zoom" {
+                    set _view($who) $_settings($this-$who)
+                    SendCmd "camera zoom $_view(zoom)"
                 }
             }
@@ -2913,41 +3023,16 @@
         bottom "0.707107 0.707107 0 0" 
     } 
-    foreach name { -qw -qx -qy -qz } value $positions($side) { 
+    foreach name { qw qx qy qz } value $positions($side) { 
         set _view($name) $value
     } 
-    set q [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
     $_arcball quaternion $q
     SendCmd "camera orient $q" 
     SendCmd "camera reset"
-    set _view(-xpan) 0.0
-    set _view(-ypan) 0.0
-    set _view(-zoom) 1.0
-    set _settings($this-xpan) $_view(-xpan)
-    set _settings($this-ypan) $_view(-ypan)
-    set _settings($this-zoom) $_view(-zoom)
-}
-
-# Reset global settings from dataset's settings.
-itcl::body Rappture::FlowvisViewer::BuildVolumeComponents {} { 
-    $itk_component(volcomponents) choices delete 0 end
-    foreach name $_componentsList {
-        $itk_component(volcomponents) choices insert end $name $name
-    }
-    set _current [lindex $_componentsList 0]
-    $itk_component(volcomponents) value $_current
-}
-
-# Reset global settings from dataset's settings.
-itcl::body Rappture::FlowvisViewer::GetDatasetsWithComponent { cname } { 
-    if { ![info exists _volcomponents($cname)] } {
-        return ""
-    }
-    set list ""
-    foreach tag $_volcomponents($cname) {
-        if { ![info exists _serverObjs($tag)] } {
-            continue
-        }
-        lappend list $tag
-    }
-    return $list
-}
+    set _view(xpan) 0.0
+    set _view(ypan) 0.0
+    set _view(zoom) 1.0
+    set _settings($this-xpan) $_view(xpan)
+    set _settings($this-ypan) $_view(ypan)
+    set _settings($this-zoom) $_view(zoom)
+}
Index: branches/1.3/gui/scripts/isomarker.tcl
===================================================================
--- branches/1.3/gui/scripts/isomarker.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/isomarker.tcl	(revision 4848)
@@ -30,157 +30,135 @@
     private common   _normalIcon [Rappture::icon nvlegendmark]
     private common   _activeIcon [Rappture::icon nvlegendmark2]
-    private method EnterTick {} 
-    private method LeaveTick {} 
-    private method StartDrag { x y } 
-    private method ContinueDrag { x y } 
-    private method StopDrag { x y } 
 
-    constructor {c obj tf args} {}
-    destructor {} 
-    public method transferfunc {} 
-    public method activate { bool } 
-    public method visible { bool } 
-    public method screenpos {} 
-    public method absval { {x "-get"} } 
-    public method relval  { {x "-get"} }
-}
-
-itcl::body Rappture::IsoMarker::constructor {c obj tf args} { 
-    set _canvas $c
-    set _nvobj $obj
-    set _tf $tf
-    set w [winfo width $_canvas]
-    set h [winfo height $_canvas]
-    set _tick [$c create image 0 $h \
-                   -image $_normalIcon -anchor s \
-                   -tags "tick $this $obj" -state hidden]
-    set _label [$c create text 0 $h \
-                    -anchor n -fill white -font "Helvetica 8" \
-                    -tags "labels $this $obj" -state hidden]
-    $c bind $_tick <Enter>           [itcl::code $this EnterTick]
-    $c bind $_tick <Leave>           [itcl::code $this LeaveTick]
-    $c bind $_tick <ButtonPress-1>   [itcl::code $this StartDrag %x %y]
-    $c bind $_tick <B1-Motion>       [itcl::code $this ContinueDrag %x %y]
-    $c bind $_tick <ButtonRelease-1> [itcl::code $this StopDrag %x %y]
-}
-
-itcl::body Rappture::IsoMarker::destructor {} {
-    $_canvas delete $this
-}
-
-itcl::body Rappture::IsoMarker::transferfunc {} {
-    return $_tf
-}
-
-itcl::body Rappture::IsoMarker::activate { bool } {
-    if  { $bool || $_activePress || $_activeMotion } {
-        $_canvas itemconfigure $_label -state normal
-        $_canvas itemconfigure $_tick -image $_activeIcon
-        $_canvas itemconfigure title -state hidden
-    } else {
-        $_canvas itemconfigure $_label -state hidden
-        $_canvas itemconfigure $_tick -image $_normalIcon
-        $_canvas itemconfigure title -state normal
+    constructor {c obj tf args} { 
+        set _canvas $c
+        set _nvobj $obj
+        set _tf $tf
+        set w [winfo width $_canvas]
+        set h [winfo height $_canvas]
+        set _tick [$c create image 0 $h \
+                -image $_normalIcon -anchor s \
+                -tags "$this $obj" -state hidden]
+        set _label [$c create text 0 $h \
+                -anchor n -fill white -font "Helvetica 8" \
+                -tags "$this $obj" -state hidden]
+        $c bind $_tick <Enter> [itcl::code $this HandleEvent "enter"]
+        $c bind $_tick <Leave> [itcl::code $this HandleEvent "leave"]
+        $c bind $_tick <ButtonPress-1> \
+            [itcl::code $this HandleEvent "start" %x %y]
+        $c bind $_tick <B1-Motion> \
+            [itcl::code $this HandleEvent "update" %x %y]
+        $c bind $_tick <ButtonRelease-1> \
+            [itcl::code $this HandleEvent "end" %x %y]
+    }
+    destructor { 
+        $_canvas delete $this
+    }
+    public method transferfunc {} {
+        return $_tf
+    }
+    public method activate { bool } {
+        if  { $bool || $_activePress || $_activeMotion } {
+            $_canvas itemconfigure $_label -state normal
+            $_canvas itemconfigure $_tick -image $_activeIcon
+        } else {
+            $_canvas itemconfigure $_label -state hidden
+            $_canvas itemconfigure $_tick -image $_normalIcon
+        }
+    }
+    public method visible { bool } {
+        if { $bool } {
+            absval $_value
+            $_canvas itemconfigure $_tick -state normal
+            $_canvas raise $_tick
+        } else {
+            $_canvas itemconfigure $_tick -state hidden
+        }
+    }
+    public method screenpos { } { 
+        set x [relval]
+        if { $x < 0.0 } {
+            set x 0.0
+        } elseif { $x > 1.0 } {
+            set x 1.0 
+        }
+        set low 10 
+        set w [winfo width $_canvas]
+        set high [expr {$w  - 10}]
+        set x [expr {round($x*($high - $low) + $low)}]
+        return $x
+    }
+    public method absval { {x "-get"} } {
+        if { $x != "-get" } {
+            set _value $x
+            set y 31
+            $_canvas itemconfigure $_label -text [format %.2g $_value]
+            set x [screenpos]
+            $_canvas coords $_tick $x [expr {$y+3}]
+            $_canvas coords $_label $x [expr {$y+5}]
+        }
+        return $_value
+    }
+    public method relval  { {x "-get"} } {
+        if { $x == "-get" } {
+            array set limits [$_nvobj limits $_tf] 
+            if { $limits(vmax) == $limits(vmin) } {
+                if { $limits(vmax) == 0.0 } {
+                    set limits(vmin) 0.0
+                    set limits(vmax) 1.0
+                } else {
+                    set limits(vmax) [expr $limits(vmin) + 1.0]
+                }
+            }
+            return [expr {($_value-$limits(vmin))/
+                          ($limits(vmax) - $limits(vmin))}]
+        } 
+        array set limits [$_nvobj limits $_tf] 
+        if { $limits(vmax) == $limits(vmin) } {
+            set limits(vmin) 0.0
+            set limits(vmax) 1.0
+        }
+        if { [catch {expr $limits(vmax) - $limits(vmin)} r] != 0 } {
+            return 0.0
+        }           
+        absval [expr {($x * $r) + $limits(vmin)}]
+    }
+    private method HandleEvent { option args } {
+        switch -- $option {
+            enter {
+                set _activeMotion 1
+                activate yes
+                $_canvas raise $_tick
+            }
+            leave {
+                set _activeMotion 0
+                activate no
+            }
+            start {
+                $_canvas raise $_tick 
+                set _activePress 1
+                activate yes
+                $_canvas itemconfigure limits -state hidden
+            }
+            update {
+                set w [winfo width $_canvas]
+                set x [lindex $args 0]
+                relval [expr {double($x-10)/($w-20)}]
+                $_nvobj overmarker $this $x
+                $_nvobj updatetransferfuncs
+            }
+            end {
+                set x [lindex $args 0]
+                if { ![$_nvobj rmdupmarker $this $x]} {
+                    eval HandleEvent update $args
+                }
+                set _activePress 0
+                activate no
+                $_canvas itemconfigure limits -state normal
+            }
+            default {
+                error "bad option \"$option\": should be start, update, end"
+            }
+        }
     }
 }
-
-itcl::body Rappture::IsoMarker::visible { bool } {
-    if { $bool } {
-        absval $_value
-        $_canvas itemconfigure $_tick -state normal
-        $_canvas raise $_tick
-    } else {
-        $_canvas itemconfigure $_tick -state hidden
-    }
-}
-
-itcl::body Rappture::IsoMarker::screenpos { } { 
-    set x [relval]
-    if { $x < 0.0 } {
-        set x 0.0
-    } elseif { $x > 1.0 } {
-        set x 1.0 
-    }
-    set low 10 
-    set w [winfo width $_canvas]
-    set high [expr {$w  - 10}]
-    set x [expr {round($x*($high - $low) + $low)}]
-    return $x
-}
-
-itcl::body Rappture::IsoMarker::absval { {x "-get"} } {
-    if { $x != "-get" } {
-        set _value $x
-        set y 31
-        $_canvas itemconfigure $_label -text [format %g $_value]
-        set x [screenpos]
-        $_canvas coords $_tick $x [expr {$y+3}]
-        $_canvas coords $_label $x [expr {$y+5}]
-    }
-    return $_value
-}
-
-itcl::body Rappture::IsoMarker::relval  { {x "-get"} } {
-    foreach {min max} [$_nvobj limits $_tf] break
-    if { $x == "-get" } {
-        if { $max == $min } {
-            if { $max == 0.0 } {
-                set min 0.0
-                set max 1.0
-            } else {
-                set max [expr $min + 1.0]
-            }
-        }
-        return [expr {($_value - $min) / ($max - $min)}]
-    } 
-    if { $max == $min } {
-        set min 0.0
-        set max 1.0
-    }
-    if { [catch {expr $max - $min} r] != 0 } {
-        return 0.0
-    }           
-    absval [expr {($x * $r) + $min}]
-}
-
-itcl::body Rappture::IsoMarker::EnterTick {} {
-    set _activeMotion 1
-    activate yes
-    $_canvas raise $_tick
-}
-
-itcl::body Rappture::IsoMarker::LeaveTick {} {
-    set _activeMotion 0
-    activate no
-}
-
-itcl::body Rappture::IsoMarker::StartDrag { x y } {
-    $_canvas raise $_tick 
-    set _activePress 1
-    activate yes
-    $_canvas itemconfigure limits -state hidden
-    $_canvas itemconfigure title -state hidden
-}
-
-itcl::body Rappture::IsoMarker::StopDrag { x y } {
-    if { ![$_nvobj removeDuplicateMarker $this $x]} {
-        ContinueDrag $x $y 
-    }
-    set _activePress 0
-    activate no
-    $_canvas itemconfigure limits -state normal
-    $_canvas itemconfigure title -state normal
-}
-
-itcl::body Rappture::IsoMarker::ContinueDrag { x y } {
-    set w [winfo width $_canvas]
-    relval [expr {double($x-10)/($w-20)}]
-    $_nvobj overMarker $this $x
-    $_nvobj updateTransferFunctions
-    $_canvas raise $_tick 
-    set _activePress 1
-    activate yes
-    $_canvas itemconfigure limits -state hidden
-    $_canvas itemconfigure title -state hidden
-}
-
